from Products.CMFCore.utils import getToolByName

from Products.ATCustomTypes.content import ATDocument
from Products.ATCustomTypes.content import ATFolder
from Products.ATCustomTypes.content import ATBTreeFolder
from Products.ATCustomTypes.content import ATTopic
from Products.ATCustomTypes.content import ATImage
from Products.ATCustomTypes.content import ATFile
from Products.ATCustomTypes.content import ATLink
from Products.ATCustomTypes.content import ATFavorite
from Products.ATCustomTypes.content import ATEvent
from Products.ATCustomTypes.content import ATNewsItem

from Products.ATCustomTypes.config import TYPES_TO_MIGRATE

new_base = {
    'Document': ATDocument,
    'Folder': ATFolder,
    'Large Plone Folder': ATBTreeFolder,
    'Topic': ATTopic,
    'File': ATFile,
    'Image': ATImage,
    'Link': ATLink,
    'Favorite': ATFavorite,
    'Event': ATEvent,
    'News Item': ATNewsItem,
    }


def migrateType(self, typename):
    """change the base class of existing instance to be our own one"""
    ct = getToolByName(self, 'portal_catalog')
    objects = [b.getObject() for b in ct(portal_type=typename)]
    for o in objects:
        o.__class__ = new_base[typename]
        o._p_changed = 1
        

def migrateTypes(self, out, types = TYPES_TO_MIGRATE):
    """call migrateType for all types where we want to have a new base"""
    for typename in types:
        if new_base.has_key(typename):
            migrateType(self, typename)
            print >> out, "migrating %s" % typename 
            
